//+------------------------------------------------------------------+
//|                                               Equity_virtual.mq4 |
//|                                         Copyright  2009, Xupypr |
//|                              http://www.mql4.com/ru/users/Xupypr |
//|                                               17.09.2009 |
//|                                 http://codebase.mql4.com/ru/5389 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Xupypr"
#property link      "http://www.mql4.com/ru/users/Xupypr"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 SteelBlue
#property indicator_color3 OrangeRed
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1

//-------------  
extern string   Default_Symbols=""; //          ,    ,       
extern double   Default_Lot=0.1;    //    ,            
extern bool     Use_M1=false;       //       
extern bool     Open_Price=true;    //       ,  -  
extern bool     Use_MM=false;       //  Money Management (    )
extern int      Deposit=10000;      //  

//-------------   
extern bool     Show_Total=true;    //    ()
extern bool     Show_Buy=false;     //    buy (  )
extern bool     Show_Sell=false;    //    sell (  )
extern bool     Show_Info=false;    //       
extern bool     Show_Vline=false;   //      / 
extern color    Trend_Color=Blue;   //   ,   
extern color    Revers_Color=Red;   //   ,      

//-------------    
extern double   Alert_Drawdown=0;   //         (0 - )
extern double   Max_Drawdown=25;    //        (" ")
extern bool     Current_Day=true;   //       
extern datetime Begin_Monitoring=D'2009.08.17 00:00'; //     ( Current_Day=false)

//-------------   
extern int      Time_Refresh=3;     //     ,         
extern datetime Time_Begin=D'2001.01.01 01:01'; //    
extern datetime Time_End=D'2011.11.11 11:11';   //    

//              .
//      ,     (Default_Symbols)   .
//        .       / .
//      ,       .
//         ,      (EURUSD+ GBPUSD-).
//       (EURUSD+1 GBPUSD-0.7).     ,     (Default_Lot).
//         .
//      .   ,        .
//        .    "[-100,150]",  -100  , 150 - .
//            .
//       ,         .
//    ,   ,  .         "$".

int      Total,TrendTotal,Window;
string   ShortName,Unique;
double   TotalEquity[],BuyEquity[],SellEquity[];
double   BuyBalance,SellBalance,MaxPeak,MaxProfit,PrevEquity;
double   AbsDrawdown,MaxDrawdown,RelDrawdown,Drawdown,RecoveryFactor;
datetime TrendTime[][2];

int      OpenBar[];    //   
int      CloseBar[];   //   
int      Type[];       //  
string   Instrument[]; // 
double   Lots[];       //  
double   OpenPrice[];  //  
double   ClosePrice[]; //  

//+------------------------------------------------------------------+
//|  Custom indicator initialization function                        |
//+------------------------------------------------------------------+
int init()
{
 SetIndexBuffer(0,TotalEquity);
 SetIndexLabel(0,"Total");
 SetIndexStyle(0,DRAW_LINE);
 SetIndexBuffer(1,BuyEquity);
 SetIndexLabel(1,"Buy");
 SetIndexStyle(1,DRAW_LINE);
 SetIndexBuffer(2,SellEquity);
 SetIndexLabel(2,"Sell");
 SetIndexStyle(2,DRAW_LINE);
 ShortName="Equity_virtual";
 if (Show_Total) ShortName=StringConcatenate(ShortName," Total");
 if (Show_Buy)   ShortName=StringConcatenate(ShortName," Buy");
 if (Show_Sell)  ShortName=StringConcatenate(ShortName," Sell");
 Unique=DoubleToStr(GetTickCount()+MathRand(),0);
 IndicatorShortName(ShortName);
 IndicatorDigits(2);
 return(0);
}
//+------------------------------------------------------------------+
//|  Custom indicator deinitialization function                      |
//+------------------------------------------------------------------+
int deinit()
{
 int total=ObjectsTotal()-1;
 for (int i=total;i>=0;i--)
 {
  string name=ObjectName(i);
  if (StringFind(name,Unique)!=-1) ObjectDelete(name);
 }
 return(0);
}
//+------------------------------------------------------------------+
//|  Custom indicator iteration function                             |
//+------------------------------------------------------------------+
int start()
{
 static int tick;
 static string minfosymbols="";
 double buyprofitloss,sellprofitloss,spread,lotsize,profit,rprofit;
 int bar,i,j,start,finish;
 string text;
 
 if (GetTickCount()-tick>Time_Refresh*1000) tick=GetTickCount();
 else return(0);
 Total=0;
 TrendTotal=0;
 for (i=0;i<ObjectsTotal();i++)
 {
  string objectname=ObjectName(i);
  if (ObjectFind(objectname)>0) continue;
  if (ObjectType(objectname)!=OBJ_TREND) continue;
  color objectcolor=ObjectGet(objectname,OBJPROP_COLOR);
  if (objectcolor==Trend_Color || objectcolor==Revers_Color) SetPosition(objectname);
 }
 if (ArraySize(OpenBar)>Total)
 {
  ArrayResize(OpenBar,Total);
  ArrayResize(Instrument,Total);
  ArrayResize(Type,Total);
  ArrayResize(OpenPrice,Total);
  ArrayResize(Lots,Total);
  ArrayResize(CloseBar,Total);
  ArrayResize(ClosePrice,Total);
 }
 if (Show_Total) ArrayInitialize(TotalEquity,Deposit);
 if (Show_Buy)   ArrayInitialize(BuyEquity,Deposit);
 if (Show_Sell)  ArrayInitialize(SellEquity,Deposit);
 if (Total==0) return(0);
 AbsDrawdown=0.0;
 MaxDrawdown=0.0;
 RelDrawdown=0.0;
 BuyBalance=0.0;
 SellBalance=0.0;
 MaxPeak=0.0;
 MaxProfit=Deposit;
 PrevEquity=Deposit;
 start=OpenBar[ArrayMaximum(OpenBar)];
 finish=iBarShift(NULL,0,Time_End);
 for (i=start;i>=finish;i--)
 {
  buyprofitloss=0.0;
  sellprofitloss=0.0;
  for (j=0;j<Total;j++)
  {
   if (OpenBar[j]>=i && CloseBar[j]<=i)
   {
    if (MarketInfo(Instrument[j],MODE_POINT)==0)
    {
     if (StringFind(minfosymbols,Instrument[j])==-1)
     {
      Alert("     "+Instrument[j]);
      minfosymbols=StringConcatenate(minfosymbols," ",Instrument[j]);
     }
     continue;
    }
    bar=iBarShift(Instrument[j],0,Time[i]);
    lotsize=LotSize(Instrument[j],Time[i]);
    if (Use_MM && OpenBar[j]==i) Lots[j]=NormalizeDouble(PrevEquity/1000*Lots[j],2);
    if (Type[j]==OP_BUY)
    {
     if (CloseBar[j]==i) BuyBalance+=(ClosePrice[j]-OpenPrice[j])*Lots[j]*lotsize;
     else buyprofitloss+=(iClose(Instrument[j],0,bar)-OpenPrice[j])*Lots[j]*lotsize;
    } 
    else
    {
     spread=MarketInfo(Instrument[j],MODE_POINT)*MarketInfo(Instrument[j],MODE_SPREAD);
     if (CloseBar[j]==i) SellBalance+=(OpenPrice[j]-ClosePrice[j]-spread)*Lots[j]*lotsize;
     else sellprofitloss+=(OpenPrice[j]-iClose(Instrument[j],0,bar)-spread)*Lots[j]*lotsize;
    }
   }
  }
  PrevEquity=NormalizeDouble(Deposit+BuyBalance+SellBalance+buyprofitloss+sellprofitloss,2);
  if (Show_Total) TotalEquity[i]=PrevEquity;
  if (Show_Buy)   BuyEquity[i]=NormalizeDouble(Deposit+BuyBalance+buyprofitloss,2);
  if (Show_Sell)  SellEquity[i]=NormalizeDouble(Deposit+SellBalance+sellprofitloss,2);
  if (Show_Info && TotalEquity[i]>0)
  {
   if (AbsDrawdown<Deposit-TotalEquity[i]) AbsDrawdown=Deposit-TotalEquity[i];
   if (PrevEquity>MaxProfit) MaxProfit=TotalEquity[i];
   if (MaxDrawdown<MaxProfit-TotalEquity[i])
   {
    MaxDrawdown=MaxProfit-TotalEquity[i];
    MaxPeak=MaxProfit;
    if (MaxPeak>0)
    {
     double relative=100*MaxDrawdown/MaxPeak;
     if (RelDrawdown<relative)
     {
      RelDrawdown=relative;
      Drawdown=MaxDrawdown;
     }
    }
   }
  }
 }
 IndicatorShortName(Unique);
 Window=WindowFind(Unique);
 IndicatorShortName(ShortName);
 finish=ArrayRange(TrendTime,0);
 if (finish>0) ArraySort(TrendTime);
 if (finish<TrendTotal) finish=TrendTotal;
 for (i=1;i<=finish;i++)
 {
  string open=StringConcatenate("#",i," in");
  string close=StringConcatenate("#",i," out");
  if (Show_Vline)
  {
   int openbar=iBarShift(NULL,0,TrendTime[i-1][0]);
   int closebar=iBarShift(NULL,0,TrendTime[i-1][1]);
   profit=TotalEquity[closebar]-TotalEquity[openbar+1];
   if (TotalEquity[openbar+1]>0) rprofit=100*profit/TotalEquity[openbar+1];
   if (profit>=0) objectcolor=Trend_Color; else objectcolor=Revers_Color;
   text=StringConcatenate(close," Bars=",openbar-closebar," Profit=",DoubleToStr(profit,2)," ",AccountCurrency(),
   " (",DoubleToStr(rprofit,2),"%) MaxDD=",DoubleToStr(MaxDrawdown(openbar+1,closebar),2)," ",AccountCurrency());
   LineCreate(open,OBJ_VLINE,1,objectcolor,open,TrendTime[i-1][0],0);
   LineCreate(close,OBJ_VLINE,1,objectcolor,text,TrendTime[i-1][1],0);
   if (i>TrendTotal)
   {
    LineDelete(open);
    LineDelete(close);
   }
  }
  else
  {
   LineDelete(open);
   LineDelete(close);
  }
 }
 if (ArrayRange(TrendTime,0)>TrendTotal) ArrayResize(TrendTime,TrendTotal);
 
 if (Show_Total) LineCreate("Total Equity",OBJ_HLINE,1,LimeGreen,"",0,TotalEquity[0]);
 else LineDelete("Total Equity");
 if (Show_Buy) LineCreate("Buy Equity",OBJ_HLINE,1,SteelBlue,"",0,BuyEquity[0]);
 else LineDelete("Buy Equity");
 if (Show_Sell) LineCreate("Sell Equity",OBJ_HLINE,1,OrangeRed,"",0,SellEquity[0]);
 else LineDelete("Sell Equity");
 if (Show_Info)
 {
  text=StringConcatenate(": ",start," bars from ",TimeToStr(Time[start]));
  LabelCreate("History",text,10);
  profit=TotalEquity[0]-Deposit;
  if (Deposit>0) rprofit=100*profit/Deposit; else rprofit=0;
  text=StringConcatenate(": ",DoubleToStr(profit,2)," ",AccountCurrency()," (",DoubleToStr(rprofit,2),"%)");
  LabelCreate("Profit",text,30);
  if (MaxDrawdown>0)
  {
   RecoveryFactor=(TotalEquity[0]-Deposit)/MaxDrawdown;
   text=StringConcatenate(": ",DoubleToStr(RecoveryFactor,2));
   LabelCreate("Recovery Factor",text,50);
  }
  text=StringConcatenate(": ",DoubleToStr(AbsDrawdown,2)," ",AccountCurrency());
  LabelCreate("Absolute Drawdown",text,70);
  if (MaxPeak>0)
  {
   text=StringConcatenate(": ",DoubleToStr(MaxDrawdown,2)," ",AccountCurrency()," (",DoubleToStr(100*MaxDrawdown/MaxPeak,2),"%)");
   LabelCreate("Maximal Drawdown",text,90);
  }
  text=StringConcatenate(": ",DoubleToStr(RelDrawdown,2),"% (",DoubleToStr(Drawdown,2)," ",AccountCurrency(),")");
  LabelCreate("Relative Drawdown",text,110);
 }
 if (Alert_Drawdown>0 && Show_Total) AlertDrawdown();
 return(0);
}
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void LabelCreate(string name, string str, int y)
{
 string objectname=StringConcatenate(name," ",Unique);
 if (ObjectFind(objectname)==-1)
 {
  ObjectCreate(objectname,OBJ_LABEL,Window,0,0);
  ObjectSet(objectname,OBJPROP_XDISTANCE,10);
  ObjectSet(objectname,OBJPROP_YDISTANCE,y);
  ObjectSet(objectname,OBJPROP_CORNER,1);
  ObjectSet(objectname,OBJPROP_COLOR,SlateGray);
 }
 ObjectSetText(objectname,name+str);
}
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void LineCreate(string name, int type, int width, color clr, string str, datetime time1, double price1, datetime time2=0, double price2=0)
{
 string objectname=StringConcatenate(name," ",Unique);
 if (ObjectFind(objectname)==-1)
 {
  ObjectCreate(objectname,type,Window,time1,price1,time2,price2);
  ObjectSet(objectname,OBJPROP_WIDTH,width);
  if (type==OBJ_TREND) ObjectSet(objectname,OBJPROP_RAY,false);
  if (type==OBJ_HLINE) ObjectSet(objectname,OBJPROP_STYLE,STYLE_DOT);
 }
 ObjectSetText(objectname,str);
 ObjectSet(objectname,OBJPROP_COLOR,clr);
 ObjectSet(objectname,OBJPROP_TIME1,time1);
 ObjectSet(objectname,OBJPROP_PRICE1,price1);
 ObjectSet(objectname,OBJPROP_TIME2,time2);
 ObjectSet(objectname,OBJPROP_PRICE2,price2);
}
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void LineDelete(string name)
{
 string objectname=StringConcatenate(name," ",Unique);
 if (ObjectFind(objectname)!=-1) ObjectDelete(objectname);
}
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
double MaxDrawdown(int in, int out)
{
 double maxprofit=0.0, maxdd=0.0;
 for (int i=in;i>=out;i--)
 {
  if (TotalEquity[i]<0) return(-1);
  if (TotalEquity[i]>maxprofit) maxprofit=TotalEquity[i];
  if (maxdd<maxprofit-TotalEquity[i]) maxdd=maxprofit-TotalEquity[i];
 }
 return(maxdd);
}
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
int AlertDrawdown()
{
 int bar=0;
 color clr;
 string drawdownstr,text;
 double relative,level,curdrawdown;
 double maxpeak,maxprofit,maxdrawdown,reldrawdown,drawdown,maxDD;
 datetime time,timehigh,timelow,timemaxprofit;
     
 if (Current_Day) time=StrToTime(TimeToStr(Time[0],TIME_DATE));
 else time=Begin_Monitoring;
 if (time<Time_Begin) time=Time_Begin;
 bar=iBarShift(NULL,0,time);
 maxprofit=0.0;
 maxdrawdown=0.0;
 reldrawdown=0.0;
 maxDD=Alert_Drawdown;
 for (int i=bar;i>=0;i--)
 {
  if (TotalEquity[i]<0) return(-1);
  if (TotalEquity[i]>maxprofit)
  {
   timemaxprofit=Time[i];
   maxprofit=TotalEquity[i];
   maxdrawdown=0.0;
   reldrawdown=0.0;
   maxDD=Alert_Drawdown;
  }
  if (maxdrawdown<maxprofit-TotalEquity[i])
  {
   maxdrawdown=maxprofit-TotalEquity[i];
   maxpeak=maxprofit;
   timehigh=timemaxprofit;
   if (maxpeak>0)
   {
    relative=NormalizeDouble(100*maxdrawdown/maxpeak,1);
    if (reldrawdown<relative)
    {
     reldrawdown=relative;
     drawdown=maxdrawdown;
     timelow=Time[i];
    }
   }
  }
 }
 if (ObjectFind("up")>0)
 {
  if (ObjectGet("up",OBJPROP_PRICE1)<TotalEquity[0])
  {
   Alert("     ",TotalEquity[0]);
   ObjectSet("up",OBJPROP_PRICE1,TotalEquity[0]);
  }
 }
 if (ObjectFind("down")>0)
 {
  if (ObjectGet("down",OBJPROP_PRICE1)>TotalEquity[0])
  {
   Alert("     ",TotalEquity[0]);
   ObjectSet("down",OBJPROP_PRICE1,TotalEquity[0]);
  }
 }
 if (reldrawdown>maxDD)
 {
  maxDD=reldrawdown;
  if (maxDD>Max_Drawdown)
  {
   text=StringConcatenate("!      ",DoubleToStr(maxDD-Max_Drawdown,1),"%\n");
   text=StringConcatenate(text,"     ",DoubleToStr(Max_Drawdown,1),"%\n");
  }
  else
  {
   text=StringConcatenate("     ",DoubleToStr(maxDD-Alert_Drawdown,1),"%\n");
   text=StringConcatenate(text,"     ",DoubleToStr(Alert_Drawdown,1),"%\n");
  }
  drawdownstr=StringConcatenate(DoubleToStr(reldrawdown,1),"% (",DoubleToStr(drawdown,2)," ",AccountCurrency(),")");
  text=StringConcatenate(text,"       ",drawdownstr,"\n");
  text=StringConcatenate(text," : ",iBarShift(NULL,0,time)," ()  ",TimeToStr(time),"\n");
  text=StringConcatenate(text," : ",ShortName);
  Alert(text);
  if (maxDD>Max_Drawdown) clr=Red;
  else clr=DarkOrange;
  LineCreate("Drawdown Line",OBJ_TREND,2,clr,"       "+drawdownstr,timehigh,maxpeak,timelow,maxpeak-drawdown);
 }
 else LineDelete("Drawdown Line");
 LineCreate("Begin Monitoring",OBJ_VLINE,1,SlateGray,"Begin Monitoring",time,0);
 level=NormalizeDouble(maxprofit,2);
 LineCreate("Max Profit",OBJ_TREND,1,DodgerBlue,"Max Profit",timemaxprofit,level,Time[0],level);
 level=NormalizeDouble(maxprofit*(1-Alert_Drawdown/100),2);
 LineCreate("Alert Drawdown",OBJ_TREND,1,DarkOrange,"Alert Drawdown "+DoubleToStr(Alert_Drawdown,1)+"%",timemaxprofit,level,Time[0],level);
 level=NormalizeDouble(maxprofit*(1-Max_Drawdown/100),2);
 LineCreate("Max Drawdown",OBJ_TREND,1,Red,"Max Drawdown "+DoubleToStr(Max_Drawdown,1)+"%",timemaxprofit,level,Time[0],level);
 if (Show_Info)
 {
  curdrawdown=maxprofit-TotalEquity[0];
  text=StringConcatenate(": ",DoubleToStr(curdrawdown,2)," ",AccountCurrency()," (",DoubleToStr(100*curdrawdown/maxprofit,2),"%)");
  LabelCreate("Current Drawdown",text,130);
 }
}
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
double LotSize(string symbol, datetime tbar)
{
 double size,close1,close2;
 string BQ,currency=AccountCurrency();
 
 if (currency=="") currency="USD";
 switch (MarketInfo(symbol,MODE_PROFITCALCMODE))
 {
  case 0:
  {
   int sbar=iBarShift(symbol,0,tbar);
   size=MarketInfo(symbol,MODE_LOTSIZE);
   if (StringSubstr(symbol,3,3)=="USD") break;
   if (StringSubstr(symbol,0,3)=="USD")
   {
    close1=iClose(symbol,0,sbar);
    if (close1>0) size=size/close1;
   }
   else
   {
    BQ=StringSubstr(symbol,0,3)+"USD";
    if (iClose(BQ,0,0)==0) BQ="USD"+StringSubstr(symbol,0,3);
    if (iClose(BQ,0,0)==0) break;
    int BQbar=iBarShift(BQ,0,tbar);
    close1=iClose(symbol,0,sbar);
    close2=iClose(BQ,0,BQbar);
    if (close1>0 && close2>0)
    {
     if (StringSubstr(BQ,0,3)=="USD") size=size/close2/close1;
     else size=size*close2/close1;
    }
   }
  } break;
  case 1: size=MarketInfo(symbol,MODE_LOTSIZE); break;
  case 2: size=MarketInfo(symbol,MODE_TICKVALUE)/MarketInfo(symbol,MODE_TICKSIZE);
 }
 if (currency!="USD")
 {
  BQ=currency+"USD";
  if (iClose(BQ,0,0)==0)
  {
   BQ="USD"+currency;
   close1=iClose(BQ,0,iBarShift(BQ,0,tbar));
   if (close1>0) size*=close1;
  }
  else
  {
   close1=iClose(BQ,0,iBarShift(BQ,0,tbar));
   if (close1>0) size/=close1;
  }
 }
 return(size);
}
//+------------------------------------------------------------------+
//|                     |
//+------------------------------------------------------------------+
bool SetPosition(string name)
{
 double corrin=0,corrout=0,priceopen,priceclose;
 int timeframe=0;
  
 datetime timeopen=ObjectGet(name,OBJPROP_TIME1);
 datetime timeclose=ObjectGet(name,OBJPROP_TIME2);
 if (timeopen==timeclose) return(false);
 if (timeopen>timeclose)
 {
  timeopen=ObjectGet(name,OBJPROP_TIME2);
  timeclose=ObjectGet(name,OBJPROP_TIME1);
 }
 if (timeopen>TimeCurrent() || timeopen<Time_Begin || timeopen>Time_End) return(false);
 int pos1=StringFind(name,"[");
 int pos2=StringFind(name,",");
 if (pos1!=-1 && pos2!=-1) corrin=StrToDouble(StringSubstr(name,pos1+1,pos2-pos1-1));
 pos1=StringFind(name,"]");
 if (pos1!=-1 && pos2!=-1) corrout=StrToDouble(StringSubstr(name,pos2+1,pos1-pos2-1));
 if (Use_M1) timeframe=PERIOD_M1;
 if (Open_Price)
 {
  priceopen=iOpen(NULL,timeframe,iBarShift(NULL,timeframe,timeopen))+corrin*MarketInfo(Symbol(),MODE_POINT);
  priceclose=iOpen(NULL,timeframe,iBarShift(NULL,timeframe,timeclose))+corrout*MarketInfo(Symbol(),MODE_POINT);
 }
 else
 {
  priceopen=iClose(NULL,timeframe,iBarShift(NULL,timeframe,timeopen))+corrin*MarketInfo(Symbol(),MODE_POINT);
  priceclose=iClose(NULL,timeframe,iBarShift(NULL,timeframe,timeclose))+corrout*MarketInfo(Symbol(),MODE_POINT);
 }
 string description=ObjectDescription(name);
 if (description=="")
 {
  if (Default_Symbols!="") description=Default_Symbols;
  else
  {
   description=Symbol();
   if (priceopen<priceclose) description=StringConcatenate(description,"+");
   else description=StringConcatenate(description,"-");
  }
  ObjectSetText(name,description);
 }
 if (StringFind(description,Symbol())!=-1)
 {
  if (ObjectGet(name,OBJPROP_PRICE1)!=priceopen) ObjectSet(name,OBJPROP_PRICE1,priceopen);
  if (ObjectGet(name,OBJPROP_PRICE2)!=priceclose) ObjectSet(name,OBJPROP_PRICE2,priceclose);
  if (ObjectGet(name,OBJPROP_TIME1)!=timeopen) ObjectSet(name,OBJPROP_TIME1,timeopen);
  if (ObjectGet(name,OBJPROP_TIME2)!=timeclose) ObjectSet(name,OBJPROP_TIME2,timeclose);
 }
 TrendTotal++;
 if (Show_Vline)
 {
  if (ArrayRange(TrendTime,0)<TrendTotal) ArrayResize(TrendTime,TrendTotal);
  TrendTime[TrendTotal-1][0]=timeopen;
  TrendTime[TrendTotal-1][1]=timeclose;
 }
 color objcolor=ObjectGet(name,OBJPROP_COLOR);
 int length=StringLen(description);
 pos2=0;
 while (pos2<length)
 {
  Total++;
  if (ArraySize(OpenBar)<Total)
  {
   ArrayResize(OpenBar,Total);
   ArrayResize(Instrument,Total);
   ArrayResize(Type,Total);
   ArrayResize(OpenPrice,Total);
   ArrayResize(Lots,Total);
   ArrayResize(CloseBar,Total);
   ArrayResize(ClosePrice,Total);
  }
  OpenBar[Total-1]=iBarShift(NULL,0,timeopen);
  CloseBar[Total-1]=iBarShift(NULL,0,timeclose);
  pos1=pos2;
  int char=0;
  while (char!=43 && char!=45 && char!=32)
  {
   pos2++;
   char=StringGetChar(description,pos2);
   if ((length-1)<pos2) break;
  }
  Type[Total-1]=OP_BUY;
  if (char==43 && objcolor==Revers_Color) Type[Total-1]=OP_SELL;
  if (char==45 && objcolor!=Revers_Color) Type[Total-1]=OP_SELL;
  Instrument[Total-1]=StringSubstr(description,pos1,pos2-pos1);
  if (Open_Price)
  {
   OpenPrice[Total-1]=iOpen(Instrument[Total-1],timeframe,iBarShift(Instrument[Total-1],timeframe,timeopen));
   ClosePrice[Total-1]=iOpen(Instrument[Total-1],timeframe,iBarShift(Instrument[Total-1],timeframe,timeclose));
  }
  else
  {
   OpenPrice[Total-1]=iClose(Instrument[Total-1],timeframe,iBarShift(Instrument[Total-1],timeframe,timeopen));
   ClosePrice[Total-1]=iClose(Instrument[Total-1],timeframe,iBarShift(Instrument[Total-1],timeframe,timeclose));
  }
  double spread=MarketInfo(Instrument[Total-1],MODE_POINT)*MarketInfo(Instrument[Total-1],MODE_SPREAD);
  if (Type[Total-1]==OP_BUY) OpenPrice[Total-1]+=spread;
  if (StringFind(name,"$")!=-1)
  {
   if (Type[Total-1]==OP_BUY) OpenPrice[Total-1]-=spread;
   if (Type[Total-1]==OP_SELL) OpenPrice[Total-1]+=spread;
  }
  if (corrin!=0) OpenPrice[Total-1]+=corrin*MarketInfo(Instrument[Total-1],MODE_POINT);
  if (corrout!=0) ClosePrice[Total-1]+=corrout*MarketInfo(Instrument[Total-1],MODE_POINT);
  pos2++;
  if (StringGetChar(description,pos2)==32 || (length-1)<pos2) Lots[Total-1]=Default_Lot;
  else
  {
   pos1=pos2;
   while(StringGetChar(description,pos2)!=32)
   {
    pos2++;
    if ((length-1)<pos2) break;
   }
   Lots[Total-1]=StrToDouble(StringSubstr(description,pos1,pos2-pos1));
  }
  pos2++;
 }
}
//+------------------------------------------------------------------+